#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

//OpenCV Lib header
#include "opencv2/opencv.hpp"

//OpenCV Libs
#pragma comment( lib, "lib/opencv_core242.lib")
#pragma comment( lib, "lib/opencv_highgui242.lib")
#pragma comment( lib, "lib/opencv_imgproc242.lib")

/* imgctl Graphic library */
#include "imgctl.h"

extern int save_GIF_Anime(char *filename,IplImage *image[],int pages,int time1);

int main(int argc,char **argv)
{
	int i,ret, t, wd,ht, page_num,page, timer;
	double tate,yoko,tate_ofs,yoko_ofs;
	double pi = 3.14159265358979323846;
	char filename[256];
	IplImage *image;
	IplImage *image_;
	IplImage *image0;
	IplImage *image1;
	IplImage *image2;
	IplImage *images[255];

	printf("<<< theta-thumbnail  version 0.1  by E.kako @kako.com >>>\n");

	if (argc!=2) {
		printf("Usage: theta-thumbnail filename\n"); return 0;
	}
	
	page_num = 60; // Number of JPEGs
	timer = 10;    // GIF Anime play time per frame  .. (unit == 1/100sec)
	
	strcpy(filename,argv[1]);
	
	
	image = cvLoadImage(filename,CV_LOAD_IMAGE_ANYCOLOR);
	if (image == NULL) {
		printf("LoadImage Error.\n"); return 1;
	}
	wd = image->width; ht = image->height;
	wd = wd / 4; ht = ht / 4;
	image_ = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	cvResize(image,image_,CV_INTER_CUBIC); 
	
	image0 = cvCreateImage(cvSize(wd,ht),IPL_DEPTH_8U, 3);
	image1 = cvCreateImage(cvSize(880,660),IPL_DEPTH_8U, 3);
	image2 = cvCreateImage(cvSize(88,66),IPL_DEPTH_8U, 3);
	
	yoko_ofs = 0;
	tate_ofs = -20;
	
	page=0;
	for (t=0;t<360;t+=6) {
		double th,ph;
		double th0,ph0;
		CvScalar s0;
		double x0,y0;
		double x1,y1;
		double x,y,z;
		double xr,yr,zr;
		double r;
		double rot;
		
		yoko = t + yoko_ofs;
		tate = 30*sin(t/90*pi) + tate_ofs;
		
		cvSet(image0, cvScalarAll(0), 0 );
		for (th0=-100;th0<+100;th0+=0.35) {
			for (ph0=-30;ph0<+30;ph0+=0.35) {
				x = 1.0 * cos(ph0/180*pi)*cos(th0/180*pi);
				y = 1.0 * cos(ph0/180*pi)*sin(th0/180*pi);
				z = 1.0 * sin(ph0/180*pi);
				rot= tate;
				yr = y;
				zr = z*cos(rot/180*pi) - x*sin(rot/180*pi);
				xr = z*sin(rot/180*pi) + x*cos(rot/180*pi);
				if (zr>1) { zr=1; }
				if (zr<-1) { zr=-1; }
				ph=asin(zr)*180/pi;
				th=atan2(yr,xr)*180/pi;
				if (ph>90) { ph=90; } else if (ph<-90) { ph=-90; }
				if (th>180) { th-=360; } else if (th<-180) { th+=360; }
				x0 = (th + yoko)/180 * (wd/2) + (wd/2); if (x0>wd) { x0-=wd; } 
				y0 = ph/90 * (ht/2) + (ht/2);
				r= ht * 0.6;
				x1 = r * cos(ph0/180*pi)*sin(th0/180*pi)*0.6;
				y1 = r * sin(ph0/180*pi) * 0.5;
				x1 += wd/2;
				y1 += ht/2;
				s0= cvGet2D(image0,y1,x1);
				if ((s0.val[0]==0)&&(s0.val[1]==0)&&(s0.val[2]==0)&&(s0.val[3]==0)) {
					cvSet2D(image0,y1,x1,cvGet2D(image_,y0,x0));
				}
			}
		}
		cvResize(image0,image1,CV_INTER_CUBIC); 
		cvSetImageROI(image1, cvRect(880/2-128,660/2-96,256,192));
		cvResize(image1,image2,CV_INTER_CUBIC); 
		cvResetImageROI(image1);
		images[page] = cvCreateImage(cvSize(88,66),IPL_DEPTH_8U, 3);
		cvCopy(image2, images[page]);
		page++;
		printf("%d/%d done.\n",page,page_num);
	}
	
	strcat(filename,".thumbnail.gif");
	
	// output to GIF anime
	ret = save_GIF_Anime(filename,images,page_num,timer);
	if (ret!=0) { printf("GIF anime output error.\n"); return 1; }
	printf("generated image(%s).\n",filename);
	cvReleaseImage(&image);
	cvReleaseImage(&image_);
	cvReleaseImage(&image0);
	cvReleaseImage(&image1);
	cvReleaseImage(&image2);
	
	
	
	return 0;
}


/* Sub */

int save_GIF_Anime(char *filename,IplImage *image[],int pages,int time1)
{
	HDIB hDibs[255];
	BITMAPINFO bmpInfo;
	unsigned char *bitmapData[255];
	DWORD ret;
	int wd,ht;
	int i,j,p;
	
	if (pages>255) { return 1; /* error: too many pages */ }
	for (p=0;p<pages;p++) {
		wd = image[p]->width;
		ht = image[p]->height;
		bitmapData[p] = (unsigned char *)malloc(wd*ht*3);
		if (bitmapData[p]==NULL) {
			return 1; // error
		}
		ZeroMemory(&bmpInfo, sizeof(bmpInfo));
		bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bmpInfo.bmiHeader.biWidth = wd;
		bmpInfo.bmiHeader.biHeight = ht;
		bmpInfo.bmiHeader.biPlanes = 1;
		bmpInfo.bmiHeader.biBitCount = 24;
		bmpInfo.bmiHeader.biCompression = BI_RGB;
		for (i=0;i<ht;i++) {
			for (j=0;j<wd;j++) {
				bitmapData[p][ (j+(ht-i-1)*wd)*3  ] = image[p]->imageData[image[p]->widthStep*i+j*3];
				bitmapData[p][ (j+(ht-i-1)*wd)*3+1] = image[p]->imageData[image[p]->widthStep*i+j*3+1];
				bitmapData[p][ (j+(ht-i-1)*wd)*3+2] = image[p]->imageData[image[p]->widthStep*i+j*3+2];
			}
		}
		// create HDIB data
		hDibs[p] = NULL;
		hDibs[p] = CreateDIB(&bmpInfo,bitmapData[p]);
	}
	
	// AnimeGIF output
	ret = DIBtoGIFAni(filename,hDibs,(DWORD)pages,(WORD)time1);
	
	if (!ret) {
		for (p=0;p<pages;p++) {
			DeleteDIB(hDibs[p]);
		}
		return 1; // Error: output failed
	}
	for (p=0;p<pages;p++) {
		free(bitmapData[p]);
		DeleteDIB(hDibs[p]);
	}
	
	return 0;
}
